""" The pdelab specific parts of the code generation process """

# Trigger some imports that are needed to have all backend implementations visible
# to the selection mechanisms
from dune.codegen.generation import (get_backend)
from dune.codegen.options import option_switch
from dune.codegen.pdelab.argument import pymbolic_coefficient
from dune.codegen.pdelab.function import pymbolic_gridfunction
from dune.codegen.pdelab.index import name_index
from dune.codegen.pdelab.spaces import (lfs_inames,
                                        )
from dune.codegen.pdelab.tensors import (pymbolic_list_tensor,
                                         pymbolic_identity,
                                         pymbolic_matrix_inverse,
                                         )


class PDELabInterface(object):
    def __init__(self):
        # The visitor instance will be registered by its init method
        self.visitor = None

    def initialize_function_spaces(self, expr, visitor):
        from dune.codegen.pdelab.spaces import initialize_function_spaces
        return initialize_function_spaces(expr, visitor)

    #
    # Tensor expression related generator functions
    #

    def pymbolic_list_tensor(self, o):
        return pymbolic_list_tensor(o, self.visitor)

    def pymbolic_identity(self, o):
        return pymbolic_identity(o)

    def pymbolic_matrix_inverse(self, o):
        return pymbolic_matrix_inverse(o, self.visitor)
